// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: IDLEState.proto

package ru.omnicomm.pegasus.messaging.online;

public final class IDLEStateParser {
  private IDLEStateParser() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public interface IDLESTARTOrBuilder
      extends com.google.protobuf.MessageOrBuilder {
    
    // optional int64 sourceId = 1;
    boolean hasSourceId();
    long getSourceId();
    
    // required int64 messageType = 2 [default = 540];
    boolean hasMessageType();
    long getMessageType();
    
    // optional int32 messageTime = 3;
    boolean hasMessageTime();
    int getMessageTime();
    
    // optional int64 timeStamp = 5;
    boolean hasTimeStamp();
    long getTimeStamp();
    
    // optional int32 messageBlock = 6;
    boolean hasMessageBlock();
    int getMessageBlock();
  }
  public static final class IDLESTART extends
      com.google.protobuf.GeneratedMessage
      implements IDLESTARTOrBuilder {
    // Use IDLESTART.newBuilder() to construct.
    private IDLESTART(Builder builder) {
      super(builder);
    }
    private IDLESTART(boolean noInit) {}
    
    private static final IDLESTART defaultInstance;
    public static IDLESTART getDefaultInstance() {
      return defaultInstance;
    }
    
    public IDLESTART getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.online.IDLEStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_IDLESTART_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.online.IDLEStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_IDLESTART_fieldAccessorTable;
    }
    
    private int bitField0_;
    // optional int64 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private long sourceId_;
    public boolean hasSourceId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    public long getSourceId() {
      return sourceId_;
    }
    
    // required int64 messageType = 2 [default = 540];
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private long messageType_;
    public boolean hasMessageType() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    public long getMessageType() {
      return messageType_;
    }
    
    // optional int32 messageTime = 3;
    public static final int MESSAGETIME_FIELD_NUMBER = 3;
    private int messageTime_;
    public boolean hasMessageTime() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    public int getMessageTime() {
      return messageTime_;
    }
    
    // optional int64 timeStamp = 5;
    public static final int TIMESTAMP_FIELD_NUMBER = 5;
    private long timeStamp_;
    public boolean hasTimeStamp() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    public long getTimeStamp() {
      return timeStamp_;
    }
    
    // optional int32 messageBlock = 6;
    public static final int MESSAGEBLOCK_FIELD_NUMBER = 6;
    private int messageBlock_;
    public boolean hasMessageBlock() {
      return ((bitField0_ & 0x00000010) == 0x00000010);
    }
    public int getMessageBlock() {
      return messageBlock_;
    }
    
    private void initFields() {
      sourceId_ = 0L;
      messageType_ = 540L;
      messageTime_ = 0;
      timeStamp_ = 0L;
      messageBlock_ = 0;
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;
      
      if (!hasMessageType()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeInt64(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeInt64(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeInt32(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeInt64(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        output.writeInt32(6, messageBlock_);
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(6, messageBlock_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }
    
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTARTOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.online.IDLEStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_IDLESTART_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.online.IDLEStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_IDLESTART_fieldAccessorTable;
      }
      
      // Construct using ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }
      
      private Builder(BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }
      
      public Builder clear() {
        super.clear();
        sourceId_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000001);
        messageType_ = 540L;
        bitField0_ = (bitField0_ & ~0x00000002);
        messageTime_ = 0;
        bitField0_ = (bitField0_ & ~0x00000004);
        timeStamp_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000008);
        messageBlock_ = 0;
        bitField0_ = (bitField0_ & ~0x00000010);
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART.getDefaultInstance();
      }
      
      public ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART build() {
        ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }
      
      private ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return result;
      }
      
      public ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART buildPartial() {
        ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART result = new ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.sourceId_ = sourceId_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.messageType_ = messageType_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.messageTime_ = messageTime_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.timeStamp_ = timeStamp_;
        if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
          to_bitField0_ |= 0x00000010;
        }
        result.messageBlock_ = messageBlock_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART other) {
        if (other == ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasMessageTime()) {
          setMessageTime(other.getMessageTime());
        }
        if (other.hasTimeStamp()) {
          setTimeStamp(other.getTimeStamp());
        }
        if (other.hasMessageBlock()) {
          setMessageBlock(other.getMessageBlock());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public final boolean isInitialized() {
        if (!hasMessageType()) {
          
          return false;
        }
        return true;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              onChanged();
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                onChanged();
                return this;
              }
              break;
            }
            case 8: {
              bitField0_ |= 0x00000001;
              sourceId_ = input.readInt64();
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              messageType_ = input.readInt64();
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              messageTime_ = input.readInt32();
              break;
            }
            case 40: {
              bitField0_ |= 0x00000008;
              timeStamp_ = input.readInt64();
              break;
            }
            case 48: {
              bitField0_ |= 0x00000010;
              messageBlock_ = input.readInt32();
              break;
            }
          }
        }
      }
      
      private int bitField0_;
      
      // optional int64 sourceId = 1;
      private long sourceId_ ;
      public boolean hasSourceId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      public long getSourceId() {
        return sourceId_;
      }
      public Builder setSourceId(long value) {
        bitField0_ |= 0x00000001;
        sourceId_ = value;
        onChanged();
        return this;
      }
      public Builder clearSourceId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        sourceId_ = 0L;
        onChanged();
        return this;
      }
      
      // required int64 messageType = 2 [default = 540];
      private long messageType_ = 540L;
      public boolean hasMessageType() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      public long getMessageType() {
        return messageType_;
      }
      public Builder setMessageType(long value) {
        bitField0_ |= 0x00000002;
        messageType_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageType() {
        bitField0_ = (bitField0_ & ~0x00000002);
        messageType_ = 540L;
        onChanged();
        return this;
      }
      
      // optional int32 messageTime = 3;
      private int messageTime_ ;
      public boolean hasMessageTime() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      public int getMessageTime() {
        return messageTime_;
      }
      public Builder setMessageTime(int value) {
        bitField0_ |= 0x00000004;
        messageTime_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageTime() {
        bitField0_ = (bitField0_ & ~0x00000004);
        messageTime_ = 0;
        onChanged();
        return this;
      }
      
      // optional int64 timeStamp = 5;
      private long timeStamp_ ;
      public boolean hasTimeStamp() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      public long getTimeStamp() {
        return timeStamp_;
      }
      public Builder setTimeStamp(long value) {
        bitField0_ |= 0x00000008;
        timeStamp_ = value;
        onChanged();
        return this;
      }
      public Builder clearTimeStamp() {
        bitField0_ = (bitField0_ & ~0x00000008);
        timeStamp_ = 0L;
        onChanged();
        return this;
      }
      
      // optional int32 messageBlock = 6;
      private int messageBlock_ ;
      public boolean hasMessageBlock() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      public int getMessageBlock() {
        return messageBlock_;
      }
      public Builder setMessageBlock(int value) {
        bitField0_ |= 0x00000010;
        messageBlock_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageBlock() {
        bitField0_ = (bitField0_ & ~0x00000010);
        messageBlock_ = 0;
        onChanged();
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.online.IDLESTART)
    }
    
    static {
      defaultInstance = new IDLESTART(true);
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.online.IDLESTART)
  }
  
  public interface IDLEENDOrBuilder
      extends com.google.protobuf.MessageOrBuilder {
    
    // optional int64 sourceId = 1;
    boolean hasSourceId();
    long getSourceId();
    
    // required int64 messageType = 2 [default = 541];
    boolean hasMessageType();
    long getMessageType();
    
    // optional int32 messageTime = 3;
    boolean hasMessageTime();
    int getMessageTime();
    
    // optional int64 timeStamp = 5;
    boolean hasTimeStamp();
    long getTimeStamp();
    
    // optional int32 messageBlock = 6;
    boolean hasMessageBlock();
    int getMessageBlock();
  }
  public static final class IDLEEND extends
      com.google.protobuf.GeneratedMessage
      implements IDLEENDOrBuilder {
    // Use IDLEEND.newBuilder() to construct.
    private IDLEEND(Builder builder) {
      super(builder);
    }
    private IDLEEND(boolean noInit) {}
    
    private static final IDLEEND defaultInstance;
    public static IDLEEND getDefaultInstance() {
      return defaultInstance;
    }
    
    public IDLEEND getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.online.IDLEStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_IDLEEND_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.online.IDLEStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_IDLEEND_fieldAccessorTable;
    }
    
    private int bitField0_;
    // optional int64 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private long sourceId_;
    public boolean hasSourceId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    public long getSourceId() {
      return sourceId_;
    }
    
    // required int64 messageType = 2 [default = 541];
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private long messageType_;
    public boolean hasMessageType() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    public long getMessageType() {
      return messageType_;
    }
    
    // optional int32 messageTime = 3;
    public static final int MESSAGETIME_FIELD_NUMBER = 3;
    private int messageTime_;
    public boolean hasMessageTime() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    public int getMessageTime() {
      return messageTime_;
    }
    
    // optional int64 timeStamp = 5;
    public static final int TIMESTAMP_FIELD_NUMBER = 5;
    private long timeStamp_;
    public boolean hasTimeStamp() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    public long getTimeStamp() {
      return timeStamp_;
    }
    
    // optional int32 messageBlock = 6;
    public static final int MESSAGEBLOCK_FIELD_NUMBER = 6;
    private int messageBlock_;
    public boolean hasMessageBlock() {
      return ((bitField0_ & 0x00000010) == 0x00000010);
    }
    public int getMessageBlock() {
      return messageBlock_;
    }
    
    private void initFields() {
      sourceId_ = 0L;
      messageType_ = 541L;
      messageTime_ = 0;
      timeStamp_ = 0L;
      messageBlock_ = 0;
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;
      
      if (!hasMessageType()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeInt64(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeInt64(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeInt32(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeInt64(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        output.writeInt32(6, messageBlock_);
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(6, messageBlock_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }
    
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEENDOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.online.IDLEStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_IDLEEND_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.online.IDLEStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_IDLEEND_fieldAccessorTable;
      }
      
      // Construct using ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }
      
      private Builder(BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }
      
      public Builder clear() {
        super.clear();
        sourceId_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000001);
        messageType_ = 541L;
        bitField0_ = (bitField0_ & ~0x00000002);
        messageTime_ = 0;
        bitField0_ = (bitField0_ & ~0x00000004);
        timeStamp_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000008);
        messageBlock_ = 0;
        bitField0_ = (bitField0_ & ~0x00000010);
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND.getDefaultInstance();
      }
      
      public ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND build() {
        ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }
      
      private ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return result;
      }
      
      public ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND buildPartial() {
        ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND result = new ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.sourceId_ = sourceId_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.messageType_ = messageType_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.messageTime_ = messageTime_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.timeStamp_ = timeStamp_;
        if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
          to_bitField0_ |= 0x00000010;
        }
        result.messageBlock_ = messageBlock_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND other) {
        if (other == ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasMessageTime()) {
          setMessageTime(other.getMessageTime());
        }
        if (other.hasTimeStamp()) {
          setTimeStamp(other.getTimeStamp());
        }
        if (other.hasMessageBlock()) {
          setMessageBlock(other.getMessageBlock());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public final boolean isInitialized() {
        if (!hasMessageType()) {
          
          return false;
        }
        return true;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              onChanged();
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                onChanged();
                return this;
              }
              break;
            }
            case 8: {
              bitField0_ |= 0x00000001;
              sourceId_ = input.readInt64();
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              messageType_ = input.readInt64();
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              messageTime_ = input.readInt32();
              break;
            }
            case 40: {
              bitField0_ |= 0x00000008;
              timeStamp_ = input.readInt64();
              break;
            }
            case 48: {
              bitField0_ |= 0x00000010;
              messageBlock_ = input.readInt32();
              break;
            }
          }
        }
      }
      
      private int bitField0_;
      
      // optional int64 sourceId = 1;
      private long sourceId_ ;
      public boolean hasSourceId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      public long getSourceId() {
        return sourceId_;
      }
      public Builder setSourceId(long value) {
        bitField0_ |= 0x00000001;
        sourceId_ = value;
        onChanged();
        return this;
      }
      public Builder clearSourceId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        sourceId_ = 0L;
        onChanged();
        return this;
      }
      
      // required int64 messageType = 2 [default = 541];
      private long messageType_ = 541L;
      public boolean hasMessageType() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      public long getMessageType() {
        return messageType_;
      }
      public Builder setMessageType(long value) {
        bitField0_ |= 0x00000002;
        messageType_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageType() {
        bitField0_ = (bitField0_ & ~0x00000002);
        messageType_ = 541L;
        onChanged();
        return this;
      }
      
      // optional int32 messageTime = 3;
      private int messageTime_ ;
      public boolean hasMessageTime() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      public int getMessageTime() {
        return messageTime_;
      }
      public Builder setMessageTime(int value) {
        bitField0_ |= 0x00000004;
        messageTime_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageTime() {
        bitField0_ = (bitField0_ & ~0x00000004);
        messageTime_ = 0;
        onChanged();
        return this;
      }
      
      // optional int64 timeStamp = 5;
      private long timeStamp_ ;
      public boolean hasTimeStamp() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      public long getTimeStamp() {
        return timeStamp_;
      }
      public Builder setTimeStamp(long value) {
        bitField0_ |= 0x00000008;
        timeStamp_ = value;
        onChanged();
        return this;
      }
      public Builder clearTimeStamp() {
        bitField0_ = (bitField0_ & ~0x00000008);
        timeStamp_ = 0L;
        onChanged();
        return this;
      }
      
      // optional int32 messageBlock = 6;
      private int messageBlock_ ;
      public boolean hasMessageBlock() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      public int getMessageBlock() {
        return messageBlock_;
      }
      public Builder setMessageBlock(int value) {
        bitField0_ |= 0x00000010;
        messageBlock_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageBlock() {
        bitField0_ = (bitField0_ & ~0x00000010);
        messageBlock_ = 0;
        onChanged();
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.online.IDLEEND)
    }
    
    static {
      defaultInstance = new IDLEEND(true);
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.online.IDLEEND)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_online_IDLESTART_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_online_IDLESTART_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_online_IDLEEND_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_online_IDLEEND_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\017IDLEState.proto\022$ru.omnicomm.pegasus.m" +
      "essaging.online\"u\n\tIDLESTART\022\020\n\010sourceId" +
      "\030\001 \001(\003\022\030\n\013messageType\030\002 \002(\003:\003540\022\023\n\013mess" +
      "ageTime\030\003 \001(\005\022\021\n\ttimeStamp\030\005 \001(\003\022\024\n\014mess" +
      "ageBlock\030\006 \001(\005\"s\n\007IDLEEND\022\020\n\010sourceId\030\001 " +
      "\001(\003\022\030\n\013messageType\030\002 \002(\003:\003541\022\023\n\013message" +
      "Time\030\003 \001(\005\022\021\n\ttimeStamp\030\005 \001(\003\022\024\n\014message" +
      "Block\030\006 \001(\005B7\n$ru.omnicomm.pegasus.messa" +
      "ging.onlineB\017IDLEStateParser"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_ru_omnicomm_pegasus_messaging_online_IDLESTART_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_online_IDLESTART_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_online_IDLESTART_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "MessageTime", "TimeStamp", "MessageBlock", },
              ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART.class,
              ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLESTART.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_online_IDLEEND_descriptor =
            getDescriptor().getMessageTypes().get(1);
          internal_static_ru_omnicomm_pegasus_messaging_online_IDLEEND_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_online_IDLEEND_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "MessageTime", "TimeStamp", "MessageBlock", },
              ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND.class,
              ru.omnicomm.pegasus.messaging.online.IDLEStateParser.IDLEEND.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  // @@protoc_insertion_point(outer_class_scope)
}
